' aoskinner.vbs
' 
'             Installation and Usage
'             Drop all the files into your
'             Funcom\Anarchy Online\cd_image\textures\Archives
'             folder. Then double click the .vbs to run.
'
' Update [Nov 01, 2002]	
'
'            Made a global find and replace to raise the number of searched 
'            for images to 412 for version 14.6. 
'            - Dovve peacefairchild@hotmail.com
' 
' Update [July 06, 2002]
'
'	Script updated to work with the 14.4 patch and pull out the
'	additional icons and skin files, as well as to put them back
'	together correctly.  Nothing else has been modified.
'
'	You may contact me or any previous authors/editors with questions
'	or comments.Please note the GNU General Public License and Copyright '	notices that follow are still valid
'	- Aranin eodred@syscheck.com
'
'
' Notice [16-03-2002]
'
'	This programme has been modified to enable the creation of skins
'	after the 14.0 patch. It is advised that you view the information
'	made avaliable at www.matthewcornish.org/ao with regards these
'	changes and for help on getting your own custom skins up to date
'	for full use with this tool and Anarchy Online.
'
'	You may contact me ((Matthew E Cornish)) via email at
'	jhanarr.skins@matthewcornish.org or send me a /tell in-game to
'	Jhanarr. Be cool, buy me a muffin today - muffins are for sharing!
'	
'	Please note the GNU General Public License and Copyright notices
'	that follow are still valid, and all further comments are those of
'	the original author. Thank you.
'
' Copyright 2001, Geoff Baysinger (AOSkinner@ergastulum.com)
'
'	This program is free software; you can redistribute it and/or modify
'	it under the terms of the GNU General Public License version 2 as 
'	published by the Free Software Foundation.
'	
'	This program is distributed in the hope that it will be useful,
'	but WITHOUT ANY WARRANTY; without even the implied warranty of
'	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'	GNU General Public License for more details.
'	
'	You should have received a copy of the GNU General Public License
'	at the end of this program; if not, write to the Free Software
'	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1355  USA
'
Version 	= "July 6th 2002"
License 	= "GPL (Gnu Public License, see http://www.gnu.org/), v2 or later"
Homepage 	= "http://www.ergastulum.com/ao/"
Author 		= "Geoff 'Jahf' Baysinger" 
Email		= "AOSkinner@ergastulum.com"
'
' NOTE:		While these comments serve as essential documentation on the script,
'			you can find a walk-through tutorial online at:
'				http://www.ergastulum.com/ao/hints/
'
' Platform:	Windows Scripting Host version 5.5
'
' Purpose:
'			This VBScript accomplishes tasks useful for 
'			creating custom skins for the MMORPG Anarchy Online:
'
'			1) extract the GUI graphics from the files "GUIGFX.UVGA"
'			(the actual image archive) and "GUIGFX.UVGI" (the text file
'			that indexes the location of each image in the archive)
'
'			2) creates a new version of the "GUIGFX.UVGA" and 
'			"GUIGFX.UVGI" files from a set of PNG images.
'
'			3) optionally crushes PNG files using PNGCrush from 
'			http://pmt.sourceforge.net/pngcrush/
'
'			4) optionally will create a .zip file of your skin
'			using InfoZip from http://www.simtel.net/pub/pd/40006.html
'
'
'
' Notes:
'
'		Shameless Plug
'
'		* Please zap me a /tell if you find this tool or the skins created 
'		  with it useful. 
'
'			You can find me in-game as (in order of play):
'			(on Rubi-Ka 1) Ceitel, Ifru, Omak, Chuckup
'			(on Rubi-Ka 2) as Jahf. 
'
'		Copyrights and Credits
'
'		* Anarchy Online (http://www.anarchy-online.com/) is Copyright
'		  2001 FunCom (http://www.funcom.com/). This script was developed
'		  without reverse engineering any compiled or encrypted code
'		  (the GUI graphics are simply a bunch of PNG files copied
'		  together into a large PNG file). I sincerely thank FunCom for 
' 		  choosing this method as it seems like AO was purposefully made 
'		  skinnable!
'
'		* If redistributing this file, please make sure and document any 
'		  changes. Also, leave the License information intact. I didn't 
'		  want to have to create a separate file for the license, so it
'		  is included at the end of this script.
'
'		* While I didn't use AO Resource Basher in the end, it is what
'		  originally made me realize this might be possible.
'
'		Installation and Usage:
'
'		* To prevent any chance of your browser trying to execute 
'		  this script, I've renamed it to "aoskinner.vbs.txt" for download.
'		  Rename it to "aoskinner.vbs" to run it.
'
'		* In most cases you should be able to double-click the file
'		  to run it.
'
'		* This script makes use of the VBScript v5.5 "RegExp" Object. 
'		  You may need to install a newer version of Windows Scripting Host
'		  to use this script. Usually this is installed with Internet Explorer
'		  but if you need a copy (or want to upgrade without installing a new
'		  version of IE), to to:
'			http://www.microsoft.com/msdownload/vbscript/scripting.asp
'
'		* This script does not use -any- custom ActiveX controls, only the
'		  core of the VBScript language. You can examine the code below, it
'		  is pretty simple and innocuous (making this a statement only
'		  I know how much I cringe when I see the '.vbs' extension). 
'
' 		* If, after installing the latest Windows Scripting Host, you 
'		  still can't run this script, you may have disabled the execution
'		  of '.vbs' files (normally to protect yourself from Outlook errors).
'		  You may try to execute the script using the 'wscript.exe' command.
'
'		* If you think you can write a better version, please do so. I chose
'		  VBScript because there is a version of it for all of the platforms
'		  that can run Anarchy Online. I'm normally a Linux / Perl hack and had
'		  not touched VB or VBScript until now.  The part of the script that 
'		  actually extracts and archives the PNG images is quite simple 
' 		  (basically just a binary read and binary copy), so go for it!
'
'		Backing Up Before You Start:
'
'		* The files "GUIGFX.UVG*" are in the 'cd_image\textures\Archives' 
'         subdirectory of your Anarchy Online program directory.
'		  If you choose to Archive a new skin, you will have to manually
'		  copy the files 'skins\[skin name]\GUIGFX.UVG*' to this 'Archives'
'		  subdirectory to use the new skin. I've left this procedure manual
'		  so that you can't blame me if you don't pay attention to the 
'		  next note :)
'
'		* ALWAYS BACK UP YOUR ORIGINAL "GUIGFX.UVG*" FILES. This script
'		  will try to do this, too, but don't rely on that (unless you
'		  like re-installing Anarchy Online :)
'
'		* If you don't want to place this VBScript in the 'Archives' 
'		  directory, you will need to make a copy of the "GUIGFX.UVG*"
'		  files in the same directory as this script. You will also 
'		  have to do some extra manual copying. However, this would
'		  be the safest method. 
'
'		* While this script attempts to be fairly user friendly,
'		  absolutely no guarantee or warranty is made as to the quality
'		  of the programming or of the results of the usage of this script.
'		  Caveat Gamer.
'
'		* This script will not delete any 'skins' directories, nor their
'		  contents (PNG files, source files, etc). You have to manually
'		  clean up after yourself to get rid of them. It will try and 
'		  warn you before overwriting files, too, but don't count on this.
'		  ALWAYS back up your source files (I found it a good practice to
'		  keep source edits in a separate PSD file so that -if- the script
'		  munched your PNG files you still have your original edits).
'
'		Image Editing Notes:
'
'		* Original AO PNG images loaded into Photoshop and then saved
'		  with no changes will grow in size. I would guess FunCom used
'		  a PNG optimizer. This means that custom skins may take up more
'		  RAM than the default skin. If you choose to use the "Crush"
'		  option in the Skinner it should shrink edited PNGs considerably.
'
'		* The PNG files will not support any alpha channels, if you
'		  save a PNG with an alpha channel it will show that area as 
'		  bright purple in-game.
'
'		* You -can- have transparency by making a pixel 100% green
'		  (R=0, G=255, B=0). This works well for floating menus, but
'		  don't try it on the side panel menus, they don't repaint 
'		  properly. Some parts of the floating menus won't like 
'		  transparency, either (same reason). Basically anything that
'		  has text painted on it may have transparency issues.
'
'		* Visit the homepage listed at the beginning of this script for
'		  skin examples. 
'
' Change Log:
'
' Version:
'	* 2001-08-06-02-02.0.04 - Initial Release
'	* 2001-08-17-13-46.0.05beta - Never released beyond beta testing
'	* 2001-08-24-22.30.0.06 ...
'		- Changed to a .zip distribution instead of text
'		- Added the ability to -drastically- shrink the size of the in-game
'		  GUI archives by using the Pngcrush utility from:
'		  http://pmt.sourceforge.net/pngcrush/
'		- Added the ability to create a ready-for-submission .zip file using 
'		  InfoZip from http://www.simtel.net/pub/pd/40006.html
'		- Slightly streamlined the RegExp calls
'		- Formatted message boxes with more detail
'		- Updated the readme with new information
' 		NOTE: You -do- need to upgrade to Windows Script Host version 5.5 in 
'		      order to run the VBScript. I originally posted that I thought it 
'			  would only require version 5.0 but this turned out to be wrong. 
'		      If you are running WSH 5.5, have downloaded the new script in .zip 
'		      format and still can't run the script, let me know (please include 
'			  the error and, if it tells you a line # and char #, tell me those) 
'			  but I can't guarantee I will be able to fix the problem.
'	* 2002-03-16 ...
'		- Edited ((matthew.cornish@breathe.com))
'		- Now able to work with the new 14.0 GUI skins
'		- This is currently under test, pending changes



Dim fso, boxTitle, choice, fileUvgi, fileUvga
boxTitle = "AOSkinner"
Set fso = CreateObject("Scripting.FileSystemObject")
fileUvga = "GUIGFX.UVGA"
fileUvgi = "GUIGFX.UVGI"

' Paranoia ... backup those files ...
' If we see a copy of the "GUIGFX.UVG?" files and no "original.GUIGFX.UVG?" then copy them
If fso.FileExists(fileUvgi) Then
	If Not fso.FileExists("original." & fileUvgi) Then
		fso.CopyFile fileUvgi, "original." & fileUvgi
	End If
End If
If fso.FileExists(fileUvga) Then
	If Not fso.FileExists("original." & fileUvga) Then
		fso.CopyFile fileUvga, "original." & fileUvga
	End If
End If

MsgBox("AO Skinner" & Chr(13) & Chr(13) & "Version " & Version & Chr(13) & Chr(13) & "Edited by: Aranin" & Chr(13) & "Email: eodred@syscheck.com" & Chr(13) & Chr(13) & Chr(13) & "*** Please go to http://www.ergastulum.com/ao/hints/ for a detailed walkthrough on using this tool ***" & Chr(13) & Chr(13) & "Original program written by " & Author & Chr(13) & Chr(13) & "Copyright 2001 " & Author & Chr(13) & "Homepage: " & Homepage & Chr(13) & "Email: " & Email)

While choice = ""
	choice = MsgBox("Do you wish to start a new skin project?" & Chr(13) & Chr(13) & "If not, you will be allowed to archive an existing project.", 291, boxTitle)
	If choice = 2 Then		' user pressed cancel
	ElseIf choice = 6 Then	' user pressed yes
		Call ExtractArchiveFiles
	Else
		choice = MsgBox("Do you want to Archive a set of skin source files?", 291, boxTitle)
		If choice = 2 Then		' user pressed cancel
		ElseIf choice = 6 Then	' user pressed yes
			Call WriteArchiveFiles
		End If
	End If
Wend

' Subroutines do it all ...

Sub ExtractArchiveFiles
	Dim folder, folders, directoryFolder, directorySuggestion, dataUvgi, countUvgi, fileReadUvga, fileReadUvgi
	folder = "skins"

	' 0) Make sure the skins directory exists
	If fso.FolderExists(folder) Then 
	Else
		createFolderSkins = MsgBox("Folder '" & folder & "' does not exist." & Chr(13) & Chr(13) & "Create it now?", 36, boxTitle)
		If createFolderSkins = 6 Then
			fso.CreateFolder(folder)
		Else
			blah = MsgBox("ERROR: Can not continue without the " & folder & " directory." & Chr(13) & Chr(13) & "Aborting ...", 16, boxTitle)
			Exit Sub
		End If
	End If
	
	' 1) dialog to customize the directory and -require- an entry, but no "\"
	directorySuggestion = 1
	While fso.FolderExists(folder & "\" & "sample" & directorySuggestion)
			directorySuggestion = directorySuggestion + 1
	Wend
	While directoryFolderGood = 0
		directoryFolder = InputBox("What would you like to name your new skin?", boxTitle, "sample" & directorySuggestion)
		If directoryFolder = "" Then 	' User clicked cancel or entered a blank value
			blah = MsgBox("ERROR: User clicked cancel or entered a blank value." & Chr(13) & Chr(13) & "Aborting ...", 16, boxTitle)
			Exit Sub
		End If
		Set regexDirectoryFolder = new RegExp
		regexDirectoryFolder.Pattern = "^[A-Za-z0-9]{1,}$"
		directoryFolderGood = regexDirectoryFolder.Test(directoryFolder)
		If directoryFolderGood = 0 Then
			blah = MsgBox("folder name must consist only of letters and numbers", 48, boxTitle)
		End If
	Wend
	
	' 2) check for the requested directory
	If fso.FolderExists(folder & "\" & directoryFolder) Then 
	Else
		createFolderSkins = MsgBox("Folder '" & folder & "\" & directoryFolder & "' does not exist." & Chr(13) & Chr(13) & "Create it now?", 36, boxTitle)
		If createFolderSkins = 6 Then
			fso.CreateFolder(folder & "\" & directoryFolder)
		Else
			blah = MsgBox("ERROR: Can not continue without the extraction directory." & Chr(13) & Chr(13) & "Aborting ...", 16, boxTitle)
			Exit Sub
		End If
	End If

    directoryFolder = "skins\" & directoryFolder & "\"

	' 3) Make sure we have the needed source files
	' Offer to extract from the original files or the current files
	whichFiles = MsgBox("Do you want to base the new skin on the original AO skin files?" & Chr(13) & Chr(13) & "If not we will use whatever skin is currently installed.", 291, boxTitle)
	If whichFiles = 2 Then			' user pressed cancel
		Exit Sub
	ElseIf whichFiles = 6 Then		' user pressed yes
		fileUvgi = "original." & fileUvgi
		fileUvga = "original." & fileUvga
	End If
	If fso.FileExists(fileUvga) Then
		Set fileReadUvga = fso.OpenTextFile(fileUvga, 1)
	Else
		blah = MsgBox("ERROR: file " & fileUvga & " does not exist or is not readable." & Chr(13) & Chr(13) & "Aborting ...", 16, boxTitle)
		Exit Sub
	End If
	If fso.FileExists(fileUvgi) Then
		Set fileReadUvgi = fso.OpenTextFile(fileUvgi, 1)
	Else
		blah = MsgBox("ERROR: file " & fileUvgi & " does not exist or is not readable." & Chr(13) & Chr(13) & "Aborting ...", 16, boxTitle)
		Exit Sub
	End If
	Set regexUvgi = new RegExp
	regexUvgi.Pattern = "GFX_([\S]{1,})[\s]([0-9]{1,})[\s]([0-9]{1,})"
	regexUvgi.Global = True
	regexUvgi.IgnoreCase = True

	' Prepare to read the file
	fileReadUvgi.SkipLine						' the first 2 lines of GUIGFX.UVGI are constant
	fileReadUvgi.SkipLine						' the first 2 lines of GUIGFX.UVGI are constant
	countUvgi = 0

	' Read the file line by line and grab images from GUIGFX.UVGA
	While countUvgi < 412					' there are 412 images in the UVGA file
		Dim matchesUvgi, matchUvgi, nameUvgi, startUvgi, sizeUvgi, fileWriteImage, dataImage
        countUvgi = countUvgi + 1			' increment
		dataUvgi = fileReadUvgi.ReadLine	' grab the next line
		' match Regular Expression to parse the line
		set matchesUvgi = regexUvgi.Execute(dataUvgi)
		nameUvgi = matchesUvgi(0).SubMatches(0)
		startUvgi = matchesUvgi(0).SubMatches(1)
		sizeUvgi = matchesUvgi(0).SubMatches(2)

		' create a file for each image
		' but first, confirm any overwriting (this is ugly)
		If fso.FileExists(directoryFolder & nameUvgi & "." & countUvgi & ".png") Then
			If fileWriteImageSkipAll = 6 Then
			Else
				If fileWriteImageOverwriteAlways = 6 Then
					set fileWriteImage = fso.CreateTextFile(directoryFolder & countUvgi & "." & nameUvgi & ".png", True)
					dataImage = fileReadUvga.Read(sizeUvgi)
					fileWriteImage.Write(dataImage)
					fileWriteImage.Close
				Else
					fileWriteImageOverwrite = MsgBox("WARNING: file " & directoryFolder & countUvgi & "." & nameUvgi & ".png already exists." & Chr(13) & Chr(13) & "Overwrite?", 291, boxTitle)
					If fileWriteImageOverwrite = 2 Then Exit Sub End If					' User clicked cancel
					If fileWriteImageOverwrite = 6 Then
						If FileWriteImageOverwriteAlways = 0 Then
							fileWriteImageOverwriteAlways = MsgBox("Do you want to overwrite all files?", 291, boxTitle)
							If fileWriteImageOverwriteAlways = 2 Then Exit Sub End If	' User clicked cancel
							set fileWriteImage = fso.CreateTextFile(directoryFolder & countUvgi & "." & nameUvgi & ".png", True)
							dataImage = fileReadUvga.Read(sizeUvgi)
							fileWriteImage.Write(dataImage)
							fileWriteImage.Close
						End If
					Else
						If FileWriteImageSkipAll = 0 Then
							fileWriteImageSkipAll = MsgBox("Do you want to skip all existing files?", 291, boxTitle)
							If fileWriteImageSkipAll = 2 Then Exit Sub End If			' User clicked cancel
						End If
					End If
				End If
			End If
		Else
			Dim padCount				' padCount just pads "0"s in the filename
			If Len(countUvgi) = 1 Then
				padCount = "00"
			ElseIf Len(countUvgi) = 2 Then
				padCount = "0"
			Else 
				padCount = ""
			End If
			set fileWriteImage = fso.CreateTextFile(directoryFolder & nameUvgi & "." & padCount & countUvgi & ".png", True)
			dataImage = fileReadUvga.Read(sizeUvgi)
			fileWriteImage.Write(dataImage)
			fileWriteImage.Close
		End If
	Wend

	' Close the files
	fileReadUvgi.Close
	fileReadUvga.Close
	
	' Done
	blah = MsgBox("Done! PNG files are extracted to:" & Chr(13) & Chr(13) & directoryFolder & "*.png", 64, boxTitle)
End Sub


Sub WriteArchiveFiles
	Dim folder, countFiles, filesFolder, indexFiles(412), imageFile, fileWriteUvgi, fileWriteUvga, byteTotal
	folder = "skins"
	directoryFolder = 0

	' 1) Make sure the "skins" directory exists
	If fso.FolderExists(folder) Then 
	Else
		blah = MsgBox("ERROR: folder " & folder & " does not exist." & Chr(13) & Chr(13) & "Aborting ...", 16, boxTitle)
		Exit Sub
	End If

	' 2) Ask what folder to Archive and confirm it exists
	While Not fso.FolderExists(folder & "\" & directoryFolder)
		directoryFolder = InputBox("What skin would you like to Archive?" & Chr(13) & Chr(13) & "If you don't know the name of the skin, just hit [enter] and I will prompt individually for each subdirectory underneath the 'skins' directory.", boxTitle, "[type here]")
		If directoryFolder = "" Then
			blah = MsgBox("ERROR: User clicked cancel or entered a blank value." & Chr(13) & Chr(13) & "Aborting ...", 16, boxTitle)
			Exit Sub
		Else
			If Not fso.FolderExists(folder & "\" & directoryFolder) Then
				blah = MsgBox("WARNING: Directory " & folder & "\" & directoryFolder & " does not exist." & Chr(13) & Chr(13) & "Please choose an existing directory:", 48, boxTitle)
				Dim listFolder, listFolderSubs, skinFolder
				Set listFolder = fso.GetFolder(folder)
				Set listFolderSubs = listFolder.SubFolders
				For Each skinFolder in listFolderSubs
					directoryFolder = MsgBox("Archive this skin folder?" & Chr(13) & Chr(13) & skinFolder, 291, boxTitle)
					If directoryFolder = 2 Then		' user pressed cancel
						Exit Sub
					ElseIf directoryFolder = 6 Then	' user pressed yes
						Dim regexSkinFolder, matchesSkinFolder
						Set regexSkinFolder = New RegExp
						regexSkinFolder.Pattern = "([^\\]{1,})$"
						Set matchesSkinFolder = regexSkinFolder.Execute(skinFolder)
						directoryFolder = matchesSkinFolder(0)
						If fso.FolderExists(folder & "\" & directoryFolder) Then
							Exit For
						Else
							blah = MsgBox("WARNING: Directory " & skinFolder & " does not exist." & Chr(13) & Chr(13) & "Please choose an existing directory:", 48, boxTitle)
						End If
					End If
				Next
			End If
		End If
	Wend
	' save the name of the folder for zipping later
	directoryName = directoryFolder
	directoryFolder = folder & "\" & directoryFolder & "\"
	
	' Offer to crush the files
	crushedFiles = MsgBox("Would you like to 'crush' the PNG files to save space?" & Chr(13) & Chr(13) & "If you select 'yes' this will create temporary copies of your PNG files and will not modify your original versions." & Chr(13) & Chr(13) & "These temporary 'crushed' files will be deleted after this script has finished." & Chr(13) & Chr(13) & "NOTE: This procedure will take a minute or two and will spew lots of text messages, let it complete and wait for the next message box.", 292, boxTitle)
	If crushedFiles = 6 Then	' user clicked Yes
		' call pngcrush and wait for it to finish
		Set crushShell = WScript.CreateObject("WScript.Shell")
		crushShell.Run("pngcrush.exe -e .png.crush " & directoryFolder & "*.png"),1,1
	End If

	' Prepopulate the indexFiles array to prevent errors (ugly)
	Dim countArray
	countArray = 0
	While countArray < 412
		countArray = countArray + 1
		indexFiles(countArray) = Array("", "")
	Wend

	Set fileWriteUvga = fso.CreateTextFile(directoryFolder & "GUIGFX.UVGA", True)
	Set fileWriteUvgi = fso.CreateTextFile(directoryFolder & "GUIGFX.UVGI", True)
	' Pattern for png files to give us the file size and order number
	Set regexImageFile = New RegExp
	regexImageFile.Pattern = "\\([^\.|^\\]{1,})\.([0-9]{1,3})\.(png|png.crush)$"
	regexImageFile.Global = True
	regexImageFile.IgnoreCase = True

	' slurp in a list of all PNG files whose filename start with digits
	Set filesFolder = fso.GetFolder(directoryFolder)
	For Each imageFile in filesFolder.Files
		Dim matchesImageFile, matchImageFile, numberImageFile, nameImageFile, extImageFile, sizeImageFile
		' if this is an image file, insert the data into the indexFiles array
		If regexImageFile.Test(imageFile) Then

	        ' Look for a crushed file to substitute 
			If crushedFiles = 6 Then	' User clicked Yes for crushing files
				If fso.FileExists(imageFile & ".crush") Then
					Set imageFile = fso.GetFile(imageFile & ".crush")
				End If
			End If

			Set matchesImageFile = regexImageFile.Execute(imageFile)
			sizeImageFile = imageFile.size

			nameImageFile = matchesImageFile(0).SubMatches(0)	' name
			numberImageFile = matchesImageFile(0).SubMatches(1)	' number
			extImageFile = matchesImageFile(0).SubMatches(2)	' extension
			indexFiles(numberImageFile) = Array(nameImageFile, sizeImageFile)

		End If
	Next
	' create the index document and archivefileWriteUvgi.WriteLine("1")
	byteTotal = 0

' Error code so that we die if we didn't fill the array with all 412 files
	countFiles = 0
	While countFiles < 412
		countFiles = countFiles + 1
		If testCount = indexFiles(countFiles)(0) Then
			blah = MsgBox("ERROR: all 412 PNG files must be in the directory." & Chr(13) & Chr(13) & "Missing at least file number " & countFiles & "." & Chr(13) & Chr(13) & "Aborting ...", 16, boxTitle)
			Exit Sub
		End If
	Wend
	
	' the first 2 lines of GUIGFX.UVGI are constant
	fileWriteUvgi.WriteLine("textures\Archives\GUIGFX.UVGA")
	fileWriteUvgi.WriteLine("412")

	countFiles = 0

	While countFiles < 412
		Dim dataImage, fileReadImage
		countFiles = countFiles + 1
		fileWriteUvgi.WriteLine("GFX_" & indexFiles(countFiles)(0) & " " & byteTotal & " " & indexFiles(countFiles)(1))
		' we add the byteTotal -afterwards- because it marks the start of the next file
		byteTotal = byteTotal + indexFiles(countFiles)(1)

		' Create the GUIGFX.UVGA file
		' ... first slurp in the next image
		Dim padCount				' padCount just pads "0"s in the filename
		If Len(countFiles) = 1 Then
			padCount = "00"
		ElseIf Len(countFiles) = 2 Then
			padCount = "0"
		Else 
			padCount = ""
		End If

		Set fileReadImage = fso.OpenTextFile(directoryFolder & indexFiles(countFiles)(0) & "." & padCount & countFiles & ".png")
		' Did we have a crushed version?
		If crushedFiles = 6 Then	' User clicked Yes for crushing files
			If fso.FileExists(directoryFolder & indexFiles(countFiles)(0) & "." & padCount & countFiles & ".png.crush") Then
				Set fileReadImage = fso.OpenTextFile(directoryFolder & indexFiles(countFiles)(0) & "." & padCount & countFiles & ".png.crush")
			End If
		End If

		dataImage = fileReadImage.Read(indexFiles(countFiles)(1))
		fileReadImage.Close
		' ... next plop it onto the file GUIGFX.UVGA
		fileWriteUvga.Write(dataImage)

		' If this is a crushed file, delete the file now
		If crushedFiles = 6 Then	' User clicked Yes for crushing files
			If fso.FileExists(directoryFolder & indexFiles(countFiles)(0) & "." & padCount & countFiles & ".png.crush") Then
				Set fileDeleteImage = fso.GetFile(directoryFolder & indexFiles(countFiles)(0) & "." & padCount & countFiles & ".png.crush")
				fileDeleteImage.Delete
			End If
		End If

	Wend
	' Close the files
	fileWriteUvga.Close
	fileWriteUvgi.Close

	blah = MsgBox("Archive files created as: " & directoryFolder & "GUIGFX.UVG*", 64, boxTitle)
	
	' Offer to zip the files up
	zipFiles = MsgBox("Would you like to package the files into a .zip archive?", 292, boxTitle)
	If zipFiles = 6 Then	' user clicked Yes

		' Clean up after any previous problems, but make sure it's ok first
		If fso.FileExists("anarchy-online-skin." & directoryName & ".zip") Then
			cleanMe = MsgBox("'anarchy-online-skin." & directoryName & ".zip' file already exists." & Chr(13) & Chr(13) & "Delete this file? If not we will not be able to create a new .zip file.", 292, boxTitle)
			If cleanMe = 6 Then	' user clicked Yes
				fso.DeleteFile(directoryName & ".zip"),1
			Else
				zipDirty = 1
			End If			
		End If
		If fso.FolderExists("cd_image") Then
			cleanMe = MsgBox("'cd_image' folder already exists." & Chr(13) & Chr(13) & "Delete this folder AND all contents? If not we will not be able to create a new .zip file.", 292, boxTitle)
			If cleanMe = 6 Then	' user clicked Yes
				fso.DeleteFolder("cd_image"),1
			Else
				zipDirty = 1
			End If			
		End If

		If zipDirty = 1 Then
			blah = MsgBox("Could not create .zip file due to existing files")
		Else
			fso.CreateFolder("cd_image")
			fso.CreateFolder("cd_image\textures")
			fso.CreateFolder("cd_image\textures\Archives")
			fso.CreateFolder("cd_image\data")
			fso.CreateFolder("cd_image\data\launcher")
			fso.CreateFolder("cd_image\data\launcher\skins")
			fso.CopyFile directoryFolder & "GUIGFX.UVGA", "cd_image\textures\Archives\",1
			fso.CopyFile directoryFolder & "GUIGFX.UVGI", "cd_image\textures\Archives\",1
			' zip launcher skins if they exist in the skin directory
			If fso.FileExists(directoryFolder & "bg.bmp") Then
				fso.CopyFile directoryFolder & "bg.bmp", "cd_image\data\launcher\skins\",1
			End If
			If fso.FileExists(directoryFolder & "prg.bmp") Then
				fso.CopyFile directoryFolder & "prg.bmp", "cd_image\data\launcher\skins\",1
			End If

			' Recurse the graphic files
			Set zipShell = WScript.CreateObject("WScript.Shell")
			zipShell.Run("zip.exe -r anarchy-online-skin." & directoryName & ".zip cd_image/*"),1,1
			
			' Leave the readme and screenshot in the main directory
			If fso.FileExists(directoryFolder & "README.TXT") Then
			  zipShell.Run("zip.exe -j anarchy-online-skin." & directoryName & ".zip " & directoryFolder & "README.TXT"),1,1
			End If
			If fso.FileExists(directoryFolder & "screenshot.jpg") Then
			  zipShell.Run("zip.exe -j anarchy-online-skin." & directoryName & ".zip " & directoryFolder & "screenshot.jpg"),1,1
			End If
			
			' Delete the cd_image folder
			fso.DeleteFolder("cd_image"),1
		End If
	End If
End Sub


'
' 		    GNU GENERAL PUBLIC LICENSE
' 		       Version 2, June 1991
' 
'  Copyright (C) 1989, 1991 Free Software Foundation, Inc.
'                        59 Temple Place, Suite 330, Boston, MA  02111-1355  USA
'  Everyone is permitted to copy and distribute verbatim copies
'  of this license document, but changing it is not allowed.
' 
' 			    Preamble
' 
'   The licenses for most software are designed to take away your
' freedom to share and change it.  By contrast, the GNU General Public
' License is intended to guarantee your freedom to share and change free
' software--to make sure the software is free for all its users.  This
' General Public License applies to most of the Free Software
' Foundation's software and to any other program whose authors commit to
' using it.  (Some other Free Software Foundation software is covered by
' the GNU Library General Public License instead.)  You can apply it to
' your programs, too.
' 
'   When we speak of free software, we are referring to freedom, not
' price.  Our General Public Licenses are designed to make sure that you
' have the freedom to distribute copies of free software (and charge for
' this service if you wish), that you receive source code or can get it
' if you want it, that you can change the software or use pieces of it
' in new free programs; and that you know you can do these things.
' 
'   To protect your rights, we need to make restrictions that forbid
' anyone to deny you these rights or to ask you to surrender the rights.
' These restrictions translate to certain responsibilities for you if you
' distribute copies of the software, or if you modify it.
' 
'   For example, if you distribute copies of such a program, whether
' gratis or for a fee, you must give the recipients all the rights that
' you have.  You must make sure that they, too, receive or can get the
' source code.  And you must show them these terms so they know their
' rights.
' 
'   We protect your rights with two steps: (1) copyright the software, and
' (2) offer you this license which gives you legal permission to copy,
' distribute and/or modify the software.
' 
'   Also, for each author's protection and ours, we want to make certain
' that everyone understands that there is no warranty for this free
' software.  If the software is modified by someone else and passed on, we
' want its recipients to know that what they have is not the original, so
' that any problems introduced by others will not reflect on the original
' authors' reputations.
' 
'   Finally, any free program is threatened constantly by software
' patents.  We wish to avoid the danger that redistributors of a free
' program will individually obtain patent licenses, in effect making the
' program proprietary.  To prevent this, we have made it clear that any
' patent must be licensed for everyone's free use or not licensed at all.
' 
'   The precise terms and conditions for copying, distribution and
' modification follow.
'
' 		    GNU GENERAL PUBLIC LICENSE
'    TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
' 
'   0. This License applies to any program or other work which contains
' a notice placed by the copyright holder saying it may be distributed
' under the terms of this General Public License.  The "Program", below,
' refers to any such program or work, and a "work based on the Program"
' means either the Program or any derivative work under copyright law:
' that is to say, a work containing the Program or a portion of it,
' either verbatim or with modifications and/or translated into another
' language.  (Hereinafter, translation is included without limitation in
' the term "modification".)  Each licensee is addressed as "you".
' 
' Activities other than copying, distribution and modification are not
' covered by this License; they are outside its scope.  The act of
' running the Program is not restricted, and the output from the Program
' is covered only if its contents constitute a work based on the
' Program (independent of having been made by running the Program).
' Whether that is true depends on what the Program does.
' 
'   1. You may copy and distribute verbatim copies of the Program's
' source code as you receive it, in any medium, provided that you
' conspicuously and appropriately publish on each copy an appropriate
' copyright notice and disclaimer of warranty; keep intact all the
' notices that refer to this License and to the absence of any warranty;
' and give any other recipients of the Program a copy of this License
' along with the Program.
' 
' You may charge a fee for the physical act of transferring a copy, and
' you may at your option offer warranty protection in exchange for a fee.
' 
'   2. You may modify your copy or copies of the Program or any portion
' of it, thus forming a work based on the Program, and copy and
' distribute such modifications or work under the terms of Section 1
' above, provided that you also meet all of these conditions:
' 
'     a) You must cause the modified files to carry prominent notices
'     stating that you changed the files and the date of any change.
' 
'     b) You must cause any work that you distribute or publish, that in
'     whole or in part contains or is derived from the Program or any
'     part thereof, to be licensed as a whole at no charge to all third
'     parties under the terms of this License.
' 
'     c) If the modified program normally reads commands interactively
'     when run, you must cause it, when started running for such
'     interactive use in the most ordinary way, to print or display an
'     announcement including an appropriate copyright notice and a
'     notice that there is no warranty (or else, saying that you provide
'     a warranty) and that users may redistribute the program under
'     these conditions, and telling the user how to view a copy of this
'     License.  (Exception: if the Program itself is interactive but
'     does not normally print such an announcement, your work based on
'     the Program is not required to print an announcement.)
'
' These requirements apply to the modified work as a whole.  If
' identifiable sections of that work are not derived from the Program,
' and can be reasonably considered independent and separate works in
' themselves, then this License, and its terms, do not apply to those
' sections when you distribute them as separate works.  But when you
' distribute the same sections as part of a whole which is a work based
' on the Program, the distribution of the whole must be on the terms of
' this License, whose permissions for other licensees extend to the
' entire whole, and thus to each and every part regardless of who wrote it.
' 
' Thus, it is not the intent of this section to claim rights or contest
' your rights to work written entirely by you; rather, the intent is to
' exercise the right to control the distribution of derivative or
' collective works based on the Program.
' 
' In addition, mere aggregation of another work not based on the Program
' with the Program (or with a work based on the Program) on a volume of
' a storage or distribution medium does not bring the other work under
' the scope of this License.
' 
'   3. You may copy and distribute the Program (or a work based on it,
' under Section 2) in object code or executable form under the terms of
' Sections 1 and 2 above provided that you also do one of the following:
' 
'     a) Accompany it with the complete corresponding machine-readable
'     source code, which must be distributed under the terms of Sections
'     1 and 2 above on a medium customarily used for software interchange; or,
' 
'     b) Accompany it with a written offer, valid for at least three
'     years, to give any third party, for a charge no more than your
'     cost of physically performing source distribution, a complete
'     machine-readable copy of the corresponding source code, to be
'     distributed under the terms of Sections 1 and 2 above on a medium
'     customarily used for software interchange; or,
' 
'     c) Accompany it with the information you received as to the offer
'     to distribute corresponding source code.  (This alternative is
'     allowed only for noncommercial distribution and only if you
'     received the program in object code or executable form with such
'     an offer, in accord with Subsection b above.)
' 
' The source code for a work means the preferred form of the work for
' making modifications to it.  For an executable work, complete source
' code means all the source code for all modules it contains, plus any
' associated interface definition files, plus the scripts used to
' control compilation and installation of the executable.  However, as a
' special exception, the source code distributed need not include
' anything that is normally distributed (in either source or binary
' form) with the major components (compiler, kernel, and so on) of the
' operating system on which the executable runs, unless that component
' itself accompanies the executable.
' 
' If distribution of executable or object code is made by offering
' access to copy from a designated place, then offering equivalent
' access to copy the source code from the same place counts as
' distribution of the source code, even though third parties are not
' compelled to copy the source along with the object code.
'
'   4. You may not copy, modify, sublicense, or distribute the Program
' except as expressly provided under this License.  Any attempt
' otherwise to copy, modify, sublicense or distribute the Program is
' void, and will automatically terminate your rights under this License.
' However, parties who have received copies, or rights, from you under
' this License will not have their licenses terminated so long as such
' parties remain in full compliance.
' 
'   5. You are not required to accept this License, since you have not
' signed it.  However, nothing else grants you permission to modify or
' distribute the Program or its derivative works.  These actions are
' prohibited by law if you do not accept this License.  Therefore, by
' modifying or distributing the Program (or any work based on the
' Program), you indicate your acceptance of this License to do so, and
' all its terms and conditions for copying, distributing or modifying
' the Program or works based on it.
' 
'   6. Each time you redistribute the Program (or any work based on the
' Program), the recipient automatically receives a license from the
' original licensor to copy, distribute or modify the Program subject to
' these terms and conditions.  You may not impose any further
' restrictions on the recipients' exercise of the rights granted herein.
' You are not responsible for enforcing compliance by third parties to
' this License.
' 
'   7. If, as a consequence of a court judgment or allegation of patent
' infringement or for any other reason (not limited to patent issues),
' conditions are imposed on you (whether by court order, agreement or
' otherwise) that contradict the conditions of this License, they do not
' excuse you from the conditions of this License.  If you cannot
' distribute so as to satisfy simultaneously your obligations under this
' License and any other pertinent obligations, then as a consequence you
' may not distribute the Program at all.  For example, if a patent
' license would not permit royalty-free redistribution of the Program by
' all those who receive copies directly or indirectly through you, then
' the only way you could satisfy both it and this License would be to
' refrain entirely from distribution of the Program.
' 
' If any portion of this section is held invalid or unenforceable under
' any particular circumstance, the balance of the section is intended to
' apply and the section as a whole is intended to apply in other
' circumstances.
' 
' It is not the purpose of this section to induce you to infringe any
' patents or other property right claims or to contest validity of any
' such claims; this section has the sole purpose of protecting the
' integrity of the free software distribution system, which is
' implemented by public license practices.  Many people have made
' generous contributions to the wide range of software distributed
' through that system in reliance on consistent application of that
' system; it is up to the author/donor to decide if he or she is willing
' to distribute software through any other system and a licensee cannot
' impose that choice.
' 
' This section is intended to make thoroughly clear what is believed to
' be a consequence of the rest of this License.
'
'   8. If the distribution and/or use of the Program is restricted in
' certain countries either by patents or by copyrighted interfaces, the
' original copyright holder who places the Program under this License
' may add an explicit geographical distribution limitation excluding
' those countries, so that distribution is permitted only in or among
' countries not thus excluded.  In such case, this License incorporates
' the limitation as if written in the body of this License.
' 
'   9. The Free Software Foundation may publish revised and/or new versions
' of the General Public License from time to time.  Such new versions will
' be similar in spirit to the present version, but may differ in detail to
' address new problems or concerns.
' 
' Each version is given a distinguishing version number.  If the Program
' specifies a version number of this License which applies to it and "any
' later version", you have the option of following the terms and conditions
' either of that version or of any later version published by the Free
' Software Foundation.  If the Program does not specify a version number of
' this License, you may choose any version ever published by the Free Software
' Foundation.
' 
'   10. If you wish to incorporate parts of the Program into other free
' programs whose distribution conditions are different, write to the author
' to ask for permission.  For software which is copyrighted by the Free
' Software Foundation, write to the Free Software Foundation; we sometimes
' make exceptions for this.  Our decision will be guided by the two goals
' of preserving the free status of all derivatives of our free software and
' of promoting the sharing and reuse of software generally.
' 
' 			    NO WARRANTY
' 
'   11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
' FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
' OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
' PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
' OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
' TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
' PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
' REPAIR OR CORRECTION.
' 
'   12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
' WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
' REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
' INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
' OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
' TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
' YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
' PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
' POSSIBILITY OF SUCH DAMAGES.
' 
' 		     END OF TERMS AND CONDITIONS
'
